## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 9;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global bootstrap 0

Name: mlton
Version: 20210117
Release: %autorelease
Summary: Optimizing compiler for Standard ML

License: MIT
URL: http://mlton.org/
Source0: http://downloads.sourceforge.net/%{name}/%{name}-%{version}.src.tgz

# Generated sources (non-binary) for bootstrapping.
# See http://mlton.org/PortingMLton#_bootstrap
#Source100: mlton-bootstrap-ppc64le-redhat-linux.tar.gz

# i686 builds recently started failing with segmentation faults,
# so exclude this arch.
# See https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch: %{ix86}

BuildRequires: make
BuildRequires: gcc gmp-devel tex(latex)

%if ! 0%{?bootstrap}
BuildRequires: mlton
%endif

Requires: gmp-devel gcc

# Filter out false dependencies.
%global __provides_exclude_from ^(%{_docdir}|%{_libdir}/mlton/sml)/.*$
%global __requires_exclude_from ^(%{_docdir}|%{_libdir}/mlton/sml)/.*$


# Description taken from the Debian package by Stephen Weeks.
%description
MLton is a whole-program optimizing compiler for Standard ML.  MLton
generates standalone executables with excellent runtime performance,
is SML 97 compliant, and has a complete basis library. MLton has
source-level profiling, a fast C FFI, an interface to the GNU
multiprecision library, and lots of useful libraries.


%prep
%autosetup -T -b 0 -p1

# https://fedoraproject.org/wiki/Packaging:Guidelines#Shebang_lines
sed -i -e '1 s;^#! */usr/bin/env *;#!/usr/bin/;' bin/*


%build
%if 0%{?bootstrap}
# Build mlton-compile from the bootstrap sources.
make dirs runtime CFLAGS="$RPM_OPT_FLAGS"

# We need the -O1 here or else RHEL 7 GCC miscompiles the bootstrap source.
for s in mlton/mlton.*.c; do
  gcc $RPM_OPT_FLAGS -O1 -c -Ibuild/lib/mlton/include \
     -Ibuild/lib/mlton/targets/self/include -w "${s}"
done
gcc $RPM_OPT_FLAGS -o build/lib/mlton/mlton-compile \
    -Lbuild/lib/mlton/targets/self \
    -L/usr/local/lib \
    mlton.*.o \
    -lmlton -lgmp -lgdtoa -lm

make basis-no-check script constants libraries tools CFLAGS="$RPM_OPT_FLAGS"

# Install this to a local location and clean. Then continue on with a
# regular build with PATH.
make install PREFIX=$(pwd)/../bootstrap
export PATH=$PATH:$(pwd)/../bootstrap/bin
make clean
%endif

make all docs PREFIX=%{_prefix} libdir=%{_libdir} CFLAGS="$RPM_OPT_FLAGS"


%install
make install-no-strip install-docs PREFIX=%{_prefix} libdir=%{_libdir} \
     docdir=%{_pkgdocdir} DESTDIR=$RPM_BUILD_ROOT

# Remove unnecessary regression test.
rm -rf $RPM_BUILD_ROOT%{_libdir}/mlton/sml/ckit-lib/regression


%files
%doc %{_pkgdocdir}
%license %{_pkgdocdir}/license/*
%{_bindir}/ml*
%{_libdir}/mlton
%{_mandir}/man1/*


%changelog
## START: Generated by rpmautospec
* Sat Nov 02 2024 Adam Goode <adam@spicenitz.org> - 20210117-9
- Fix incorrect autochangelog and add autorelease

* Sat Nov 02 2024 Adam Goode <adam@spicenitz.org> - 20210117-7
- Increment release version to build new package

* Sat Nov 02 2024 Adam Goode <adam@spicenitz.org> - 20210117-6
- Stop building mlton for i686

* Sat Nov 02 2024 Adam Goode <adam@spicenitz.org> - 20210117-5
- Remove out-of-order changelogs in favor of %%autochangelog

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 20210117-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Thu Jan 25 2024 Fedora Release Engineering <releng@fedoraproject.org> - 20210117-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Jan 21 2024 Fedora Release Engineering <releng@fedoraproject.org> - 20210117-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Oct 13 2023 Adam Goode <adam@spicenitz.org> - 20210117-1
- Update to latest upstream release (rhbz#2243778)

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 20180207-26
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 20180207-25
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 20180207-24
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 20180207-23
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 20180207-22
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 20180207-21
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Fri Jan 08 2021 Tom Stellard <tstellar@redhat.com> - 20180207-20
- Add BuildRequires: make

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 20180207-19
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 20180207-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 20180207-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sun Apr 28 2019 Adam Goode <adam@spicenitz.org> - 20180207-16
- Update bootstrap sources for ppc64le patch

* Sun Apr 28 2019 Adam Goode <adam@spicenitz.org> - 20180207-15
- Add missing ppc64le patch

* Sat Apr 27 2019 Adam Goode <adam@spicenitz.org> - 20180207-14
- Try to rebootstrap ppc64le to fix segfault

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 20180207-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Mon Jul 23 2018 Adam Goode <adam@spicenitz.org> - 20180207-12
- finish bootstrap

* Mon Jul 23 2018 Adam Goode <adam@spicenitz.org> - 20180207-11
- BuildRequires gcc

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 20180207-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Apr 04 2018 Adam Goode <adam@spicenitz.org> - 20180207-9
- Bootstrap RISC-V

* Sun Apr 01 2018 Adam Goode <adam@spicenitz.org> - 20180207-8
- Finalize bootstrap

* Sun Apr 01 2018 Adam Goode <adam@spicenitz.org> - 20180207-7
- Fix wrong shebang lines

* Sun Apr 01 2018 Adam Goode <adam@spicenitz.org> - 20180207-6
- Fix EPEL build and modernize specfile

* Sun Apr 01 2018 Adam Goode <adam@spicenitz.org> - 20180207-5
- Bootstrap

* Sat Mar 31 2018 Adam Goode <adam@spicenitz.org> - 20180207-4
- Remove workaround

* Sat Mar 31 2018 Adam Goode <adam@spicenitz.org> - 20180207-3
- Fix broken release

* Thu Mar 22 2018 Adam Goode <adam@spicenitz.org> - 20180207-2
- Fix bootstrap

* Thu Mar 22 2018 Adam Goode <agoode@google.com> - 20180207-1
- mlton-20180207

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 20130715-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 20130715-13
- Rebuilt for
  https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 20130715-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Jul 07 2017 Igor Gnatenko <ignatenko@redhat.com> - 20130715-11
- Rebuild due to bug in RPM (RHBZ #1468476)

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 20130715-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Sep 06 2016 Peter Robinson <pbrobinson@gmail.com> - 20130715-9
- Add ExcludeArch until those arches are bootstrapped (rhbz 1056365)

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 20130715-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Dennis Gilmore <dennis@ausil.us> - 20130715-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Aug 17 2014 Peter Robinson <pbrobinson@fedoraproject.org> - 20130715-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Dennis Gilmore <dennis@ausil.us> - 20130715-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun Sep 29 2013 Adam Goode <adam@spicenitz.org> - 20130715-4
- Fix bz#1013323

* Sat Sep 28 2013 Adam Goode <adam@spicenitz.org> - 20130715-3
- Use pkgdocdir instead of docdir

* Thu Sep 26 2013 Adam Goode <adam@spicenitz.org> - 20130715-2
- Switch to unversioned docdir

* Thu Sep 26 2013 Adam Goode <adam@spicenitz.org> - 20130715-1
- New upstream release

* Sat Aug 03 2013 Dennis Gilmore <dennis@ausil.us> - 20100608-28
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Apr 27 2013 Adam Goode <adam@spicenitz.org> - 20100608-27
- Add todo file

* Sat Apr 27 2013 Adam Goode <adam@spicenitz.org> - 20100608-26
- Remove script used for polyml bootstrap

* Sat Apr 27 2013 Adam Goode <adam@spicenitz.org> - 20100608-25
- MLton is too big for polyml, so bootstrap arm, armhfp, ppc, ppc64 with
  mlton
- Don't use htmldoc anymore, it often crashes
- Remove max-heap workaround

* Thu Apr 25 2013 Adam Goode <adam@spicenitz.org> - 20100608-24
- Remove htmldoc docs

* Thu Apr 25 2013 Adam Goode <adam@spicenitz.org> - 20100608-23
- add missing %%endif

* Thu Apr 25 2013 Adam Goode <adam@spicenitz.org> - 20100608-22
- Remove max-heap workaround

* Tue Apr 23 2013 Adam Goode <adam@spicenitz.org> - 20100608-21
- Scrap all the arch-specific bootstrapping, use polyml to do it

* Sun Apr 21 2013 Adam Goode <adam@spicenitz.org> - 20100608-20
- Try a more generalized bootstrap approach

* Sat Apr 20 2013 Adam Goode <adam@spicenitz.org> - 20100608-19
- Really fix builds by more intelligently setting max-heap

* Sat Apr 20 2013 Adam Goode <adam@spicenitz.org> - 20100608-18
- Fix ppc64 bootstrap

* Sat Apr 20 2013 Adam Goode <adam@spicenitz.org> - 20100608-17
- Bootstrap ppc64

* Sat Apr 20 2013 Adam Goode <adam@spicenitz.org> - 20100608-16
- Bootstrap ppc

* Fri Apr 19 2013 Adam Goode <adam@spicenitz.org> - 20100608-15
- Add comment for ppc64 patch

* Fri Apr 19 2013 Adam Goode <adam@spicenitz.org> - 20100608-14
- Fix detection of ppc64, fix building on large-ram machines

* Mon Apr 15 2013 Adam Goode <adam@spicenitz.org> - 20100608-13
- Fix for #914188 FTBFS
- Update source link
- Remove ExclusiveArch, per packaging recommendations

* Thu Feb 14 2013 Dennis Gilmore <dennis@ausil.us> - 20100608-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Jul 20 2012 Dennis Gilmore <dennis@ausil.us> - 20100608-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jan 13 2012 Dennis Gilmore <dennis@ausil.us> - 20100608-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Wed Oct 26 2011 Marcela Mašláňová <mmaslano@redhat.com> - 20100608-9
- rebuild with new gmp without compat lib

* Wed Oct 12 2011 Marcela Mašláňová <mmaslano@redhat.com> - 20100608-8
- rebuild with new gmp

* Fri Aug 12 2011 Adam Goode <adam@spicenitz.org> - 20100608-7
- Clean up auto dependencies

* Fri Mar 11 2011 Dan Horák <dan@danny.cz> - 20100608-6
- set ExclusiveArch

* Tue Feb 08 2011 Dennis Gilmore <dennis@ausil.us> - 20100608-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Thu Jul 29 2010 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 20100608-3
- dist-git conversion

* Fri Jun 11 2010 Adam Goode <agoode@fedoraproject.org> - 20100608-2
- Change location of upstream source

* Fri Jun 11 2010 Adam Goode <agoode@fedoraproject.org> - 20100608-1
- New upstream release, see http://mlton.org/Release20100608

* Wed Jan 06 2010 Adam Goode <agoode@fedoraproject.org> - 20070826-24
- Change some %%define into %%global

* Wed Nov 25 2009 Bill Nottingham <notting@fedoraproject.org> - 20070826-23
- Fix typo that causes a failure to update the common directory. (releng
  #2781)

* Sat Jul 25 2009 Jesse Keating <jkeating@fedoraproject.org> - 20070826-22
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sun May 31 2009 Adam Goode <agoode@fedoraproject.org> - 20070826-21
- Add forgotten changelog entry

* Sun May 31 2009 Adam Goode <agoode@fedoraproject.org> - 20070826-20
- Use non-trunk version of MLton to bootstrap ARM

* Sun May 31 2009 Adam Goode <agoode@fedoraproject.org> - 20070826-19
- Use non-trunk version of MLton to bootstrap ARM

* Wed May 27 2009 Adam Goode <agoode@fedoraproject.org> - 20070826-18
- Add missing ARM patch

* Wed May 27 2009 Adam Goode <agoode@fedoraproject.org> - 20070826-17
- Bootstrap ARM

* Thu Feb 26 2009 Jesse Keating <jkeating@fedoraproject.org> - 20070826-16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Aug 30 2008 Adam Goode <agoode@fedoraproject.org> - 20070826-15
- RPM 4.6 fix for patch tag - Update LaTeX build requires

* Sun Feb 24 2008 Adam Goode <agoode@fedoraproject.org> - 20070826-14
- Change latex build requires

* Sat Feb 09 2008 Adam Goode <agoode@fedoraproject.org> - 20070826-13
- Introduce patch to not call mprotect with PROT_EXEC

* Fri Jan 18 2008 Adam Goode <agoode@fedoraproject.org> - 20070826-12
- Rebuild for new GCC

* Fri Sep 28 2007 Adam Goode <agoode@fedoraproject.org> - 20070826-11
- Disable bootstrap

* Thu Sep 27 2007 Adam Goode <agoode@fedoraproject.org> - 20070826-10
- Re-bootstrap ppc

* Wed Sep 26 2007 Adam Goode <agoode@fedoraproject.org> - 20070826-9
- Really fix SRPM conditionals

* Wed Sep 26 2007 Adam Goode <agoode@fedoraproject.org> - 20070826-8
- Work around strange SRPM problem in conditionals - Fix changelog (forgot
  release 5?)

* Wed Sep 26 2007 Adam Goode <agoode@fedoraproject.org> - 20070826-7
- Work around strange SRPM problem in conditionals

* Wed Sep 26 2007 Adam Goode <agoode@fedoraproject.org> - 20070826-6
- Build on ppc now that #247407 is fixed

* Fri Sep 14 2007 Adam Goode <agoode@fedoraproject.org> - 20070826-5
- unbootstrap

* Thu Sep 13 2007 Adam Goode <agoode@fedoraproject.org> - 20070826-4
- Do not condition bootstrap source tag

* Thu Sep 13 2007 Adam Goode <agoode@fedoraproject.org> - 20070826-3
- Bootstrap x86_64

* Tue Aug 28 2007 Adam Goode <agoode@fedoraproject.org> - 20070826-2
- Exclude ppc for now (GCC internal compiler error!)

* Mon Aug 27 2007 Adam Goode <agoode@fedoraproject.org> - 20070826-1
- Update to new release

* Wed Aug 22 2007 Adam Goode <agoode@fedoraproject.org> - 20061107-8
- Exclude ppc64 for now

* Wed Aug 22 2007 Adam Goode <agoode@fedoraproject.org> - 20061107-7
- Update license tag - Rebuild for buildid

* Wed Aug 08 2007 Adam Goode <agoode@fedoraproject.org> - 20061107-6
- license clarification

* Wed Jan 31 2007 Adam Goode <agoode@fedoraproject.org> - 20061107-5
- add bug number for exclude arch

* Sat Nov 25 2006 Adam Goode <agoode@fedoraproject.org> - 20061107-4
- fixes

* Thu Nov 16 2006 Adam Goode <agoode@fedoraproject.org> - 20061107-3
- version

* Wed Nov 15 2006 Adam Goode <agoode@fedoraproject.org> - 20061107-2
- debug

* Mon Nov 13 2006 Adam Goode <agoode@fedoraproject.org> - 20061107-1
- new mlton

* Fri Sep 01 2006 Adam Goode <agoode@fedoraproject.org> - 20051202-5
- rebuilt

* Fri Sep 01 2006 Adam Goode <agoode@fedoraproject.org> - 20051202-4
- rebuild

* Sun Aug 27 2006 Ville Skyttä <scop@fedoraproject.org> - 20051202-3
- http://fedoraproject.org/wiki/Extras/Schedule/FC6MassRebuild

* Mon Jul 10 2006 Adam Goode <agoode@fedoraproject.org> - 20051202-2
- turn off bootstrapping

* Sun Jul 09 2006 Adam Goode <agoode@fedoraproject.org> - 20051202-1
- auto-import mlton-20051202-7 on branch devel from
  mlton-20051202-7.src.rpm
## END: Generated by rpmautospec
